UNIT mTAnwendung;

interface

uses  mSuM, mUhr,mTKnopf, mTKreisknopf, mTRechteckKnopf, mTMuehle;
// Uses-Klausel ggf. anpassen

type
   TAnwendung = CLASS

     // Attribute
     private
        derBildschirm : Bildschirm;
        dieMaus : Maus;
        hatStift : Stift;
        dieTastatur : Tastatur;
        KSchneller :TKreisknopf;
        KLangsamer :TKreisknopf;
        KEnde :TRechteckknopf ;
        dieUhr :Uhr;
        Muehle1 :TMuehle;
        Muehle2 :TMuehle;

     // Methoden
     public
        constructor init;
        procedure run;
        destructor gibFrei;

   end;

implementation

//+---------------------------------------------------------------------
//|         TAnwendung: Methodendefinition
//+---------------------------------------------------------------------

//-------- init (public) -----------------------------------------------
constructor TAnwendung.init;
begin
  derBildschirm := Bildschirm.init;
  dieMaus       := Maus.init;
  hatStift      := Stift.init;
  dieTastatur   := Tastatur.init;
  dieUhr        := Uhr.init;
  KSchneller    := TKreisknopf.init(20,20,10,'+',dieMaus);
  KLangsamer    := TKreisknopf.init(20,50,10,'---',dieMaus);
  KEnde         := TRechteckknopf.init(300,400,80,'ENDE',dieMaus);
  Muehle1       := TMuehle.init(60,300,100,3,rot);
  Muehle2       := TMuehle.init(400,200,80,2,blau);
end;

//-------- run (public) ------------------------------------------------
procedure TAnwendung.run;
begin
   repeat
         if KSchneller.angeklickt then begin
            Muehle1.schneller;
            Muehle2.schneller;
         end
         else if KLangsamer.angeklickt then begin
            Muehle1.langsamer;
            Muehle2.langsamer;
         end;
         muehle1.drehe;
         muehle2.drehe;
         dieUhr.warte(10)
   until KEnde.angeklickt
end;

//-------- gibFrei (public) --------------------------------------------
destructor TAnwendung.gibFrei;
begin
  dieTastatur.gibFrei;
  dieMaus.gibFrei;
  derBildschirm.gibFrei
end;

end.
